""" Le type list : par référence ou par valeurs ?
-> copie de la référence ou des éléments de la liste """

l0 = [ "l0", 1, 2, 3 ]
print(f"Adr l0 -> 0x{id(l0):x} | l0 : {l0}")

l1 = l0 # l0 et l1 vont référer le même espace mémoire
print(f"Adr l1 -> 0x{id(l1):x} | l1 : {l1}")

l1[0] = "l1" # modifier l1 implique une modification de l0
print('\nAprès modification de l1[0] = "l1" ')
print(f"\t l0 est aussi modifiée  : {l0}")

l2 = l0[:] # recopier l'info. sur un autre espace mémoire
print(f"\nAdr l2 -> 0x{id(l2):x} | l2 : {l2}")

l2[0] = "l2" # l2 est à un autre espace mémoire que l0
print(f"\t l0 inchangée : {l0}")
print(f"\t l2 modifiée  : {l2}")
